\titre;PicT870di  16F870  clignote  registre  dcalage avec interruptions
\b;RA0..5  RB0..7 RC0..7  priode 0.65 s

.Proc	16f870
.Ref	16F870

Perio	= 100
TPhase	= Perio/2
Valeur	= 16'55

.Loc	DebVar
.Ins	DtVar.asi
Motif:	.16	1

;PortB
bD	= 7
bCk	= 6
bS1	= 0
.Macro	S1On
	Set	PortA:#bS1
.EndMacro
.Macro	S1Off
	Clr	PortA:#bS1
.Endmacro

.Loc	0
Jump	Deb

.Loc	4	; Interrupts
\prog;Interrupt| 
S1On	; Sync
	Move	W,SaveW	; Ne modifie pas F
	Swap	F,W	; A cause du retour
	Move	W,SaveF

	Clr	Intcon:#TOIF
	Move	#256-TPhase+2+2,W
	Move	W,TMR0

.Ins	XTimeT.asi

	Swap	SaveF,W  	; Un Move modifierait F!!
	Move	W,F	 	;  artefact du PIC
	Swap	SaveW	 	;  se souvenir du truc
	Swap	SaveW,W  	; Un Move modifierait F!!
S1Off
	RetI

Deb:	Clr	PortA
	Set	Status:#RP0
	Move	#16'06,W
	Move	W,AdCon1
 	Move	#0,W		; sorties
	Move	W,PortA
	Move	W,PortB
	Move	W,PortC
	Clr	Status:#RP0

	Move	#2'10100000,W	; GIE and TOIE on
	Move	W,IntCon

	Move	#Valeur,W
	Move	W,Motif
Loop:
	Not	Motif
	Move	Motif,W

	Call	SndS8
; Attente
  A$:	DecSkip,EQ	C1
	Jump	A$
	DecSkip,EQ	C2
	Jump	A$
	
	Jump	Loop

\macros;Registre  dcalage srie|
\b;Les transferts durent 60 us et ne doivent tre espacs
\b;de 1  10 ms au moins.
.Macro	SetD
	Set	PortB:#bD
	Nop
.EndMacro
.Macro	ClrD
	Clr	PortB:#bD
	Nop
.EndMacro

.Macro	SetCk
	Set	PortB:#bCk
.EndMacro
.Macro	ClrCk
	Clr	PortB:#bCk
.EndMacro
.Macro	FullCk	; Ck  .../'''\...
	SetCk
	Nop		; 1 \mu;s pulse min
	ClrCk
.EndMacro

\rout;SndS8|Envoie et lit 8 bits, sans Start/Stop
; Dure 85 microsecondes
\in;W  (data in)
\out;W = DataOut
\mod;W SCnt  DataOut
; CK  ________/'\\__/'\\__/'\\_... _/'\\_____
; Dout XXXXX\\_===\\_===\\_=== ... \\========
SndS8:
	Move	W,Data
	Move	#8,W
	Move	W,C1
  L$:
	ClrD
	RLC	Data
	Skip,CC
	SetD
	FullCk
	DecSkip,EQ C1
	Jump	L$
	Ret

.Align	16'8
.16	"P","i","c","t","8","7","0","d"
.Fill.16 	FinProg+1-APC,-1
.Loc	16'2007
.16	16'3F39	; Config
.End

